package org.nissley.bluetooth_tester;

import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by John Nissley on 1/2/2017.
 */

public class GPSRowArrayAdapter extends ArrayAdapter<GPSRow>{
    private Context context;
    private List<GPSRow> GPSRows;
    //constructor, call on creation
    public GPSRowArrayAdapter(Context context, int resource, ArrayList<GPSRow> objects) {
        super(context, resource, objects);
        this.context = context;
        this.GPSRows = objects;
    }
    //called when rendering the list
    public View getView(int position, View convertView, ViewGroup parent) {
        //get the property we are displaying
        GPSRow gpsRow = GPSRows.get(position);
        //get the inflater and inflate the XML layout for each item
        LayoutInflater inflater = (LayoutInflater) context.getSystemService(Activity.LAYOUT_INFLATER_SERVICE);
        View view = inflater.inflate(R.layout.gps_list_row, null);
        LinearLayout row = (LinearLayout) view.findViewById(R.id.lo_gps_row);
        TextView gpsDateTime = (TextView) view.findViewById(R.id.tv_gps_date_time_txt);
        TextView gpsSats = (TextView) view.findViewById(R.id.tv_gps_sats_txt);
        TextView gpsLatLng = (TextView) view.findViewById(R.id.tv_gps_lat_lng_txt);
        TextView gpsAlt = (TextView) view.findViewById(R.id.tv_gps_alt_txt);
        TextView gpsSpeed = (TextView) view.findViewById(R.id.tv_gps_speed_txt);
        TextView gpsAccuracy = (TextView) view.findViewById(R.id.tv_gps_accuracy_txt);
        Integer accuracy = gpsRow.getAccuracy();
        if (accuracy <= 130) {
            row.setBackgroundColor(Color.GREEN);
        } else if (accuracy <= 200) {
            row.setBackgroundColor(Color.YELLOW);
        } else {
            row.setBackgroundColor(Color.RED);
        }
        gpsDateTime.setText(gpsRow.getDate() + " " + gpsRow.getTime());
        gpsSats.setText(String.valueOf(gpsRow.getSats()));
        gpsLatLng.setText(gpsRow.getLat() + ", " + gpsRow.getLng());
        gpsAlt.setText(String.valueOf(gpsRow.getAlt()));
        gpsSpeed.setText(String.valueOf(gpsRow.getSpeed()));
        gpsAccuracy.setText(String.valueOf(gpsRow.getAccuracy()));
        return view;
    }
}
